#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>

void print_help(char name[])
{
    printf("\n");
    printf("Simulates execution of an program. \n");
    printf("\n");
    printf("Usage: %s name time [-eNN=MM [...]]\n", name);
    printf("   name      A label to print\n");
    printf("   time      Time for program to sleep in seconds\n"); 
    printf("\n");
    printf("The default action of the program is to return with 0 (success) \n");
    printf(" -eNN=MM     Return with value NN with a probability of MM% \n");
    printf("\n");
}


void parse_argv(char argv[], int *retval, int *percentage)
{
    if ( sscanf(argv,"-e %d = %d",retval,percentage)!=2 )
    {
	printf("Argument sytax error : %s \n", argv);
	exit(EXIT_FAILURE);
    }

    if ( *percentage <= 0 )
    {
	printf("Percentage argument must be > 0");
	exit(EXIT_FAILURE);
    }
}



int main (int argc, char** argv)
{
    char *name;
    int sleep_time, i, rand_value, retval, sum;
    int retvals[100];
    int percentages[100];
    struct timeval td;
	
    if (argc < 3 )
    {
	print_help(argv[0]);
	return 1;
    }	
	
    
    
    name = argv[1];


    if ( sscanf(argv[2],"%d",&sleep_time)!=1 )
    {
	printf("Argument sytax error : %s \n", argv[2]);
	return 1;
    }
    
    for (i=3; i<argc; i++)
    {
	parse_argv(argv[i], retvals+i-3, percentages+i-3);
    }

        
    /* Get random number in interval [0,100) */
    gettimeofday(&td,0);
    srand(td.tv_usec);
    rand_value = rand() % 100;  //I know, bad practice
    
    /* See if we want to fire an "error" */
    retval = 0;
    sum = 0;
    for (i=0; i<argc-3; i++)
    {
	sum += percentages[i];
	if ( rand_value < sum )
	{
		retval = retvals[i];
		break;
	}
    }

    /* Sleep */
    sleep(sleep_time);
    
    /* Print result */ 
    printf( name );
    for (i=0; i<70-strlen(name); i++)
    {
	putchar('.');
    }
    printf("%d\n", retval);
    
    return retval;
}
